package visualization;

import java.util.Vector;

import ontology.OntologyInstance;

class OntologyInstanceView extends OntologyObjectView
{
 String _display_with_links;

 OntologyInstanceView (OntologyInstance oi) { super (oi); _display_with_links = ""; }

 public String display ()
 {
  //if (_display.equals (""))
  if (false)
     {
      String name = ((OntologyInstance) _the_object).getName ();
      _display += "<h1>" + name + "</h1><br>";
      _display += "<h2>Id: " + ((OntologyInstance) _the_object).getId () + "</h2><br><br>";

      Vector <String> syns = ((OntologyInstance) _the_object).getObjectOfPropertyByPropertyIdAsVector ("synonym");
      if (syns != null)
         {
    	  System.out.println (((OntologyInstance) _the_object).getId () + " " + syns.size () + " synonyms");
          _display += "<h2>Synonyms:</h2>";
          for (int j = 0; j < syns.size (); j++)
        	  _display += syns.get(j) + "<br>";
        	  
          }
      else
    	  System.out.println (((OntologyInstance) _the_object).getId () + " no synonym");
      }

  // New version:
  if ("".equals(_display))
     {
	  Vector <String> desc = ((OntologyInstance) _the_object).getFullDescription ();
	  if (desc == null)
	     {
		  String name = ((OntologyInstance) _the_object).getName ();
	      _display += "<h1>" + name + "</h1><br>";
	      _display += "<h2>Id: " + ((OntologyInstance) _the_object).getId () + "</h2><br><br>";

	      Vector <String> syns = ((OntologyInstance) _the_object).getObjectOfPropertyByPropertyIdAsVector ("synonym");
	      if (syns != null)
	         {
	    	  System.out.println (((OntologyInstance) _the_object).getId () + " " + syns.size () + " synonyms");
	          _display += "<h2>Synonyms:</h2>";
	          for (int j = 0; j < syns.size (); j++)
	        	  _display += syns.get(j) + "<br>";
	        	  
	          }
	      else
	    	  System.out.println (((OntologyInstance) _the_object).getId () + " no synonym");
	      }
	  else
	     {
		  String name = ((OntologyInstance) _the_object).getName ();
	      _display += "<h1>" + name + "</h1><br>";
	      _display += "<h2>Id: " + ((OntologyInstance) _the_object).getId () + "</h2><br><br>";
	      for (int i = 0; i < desc.size (); i++)
	          {
               String [] words = desc.get(i).split(": ");
               if ((! "id".equals (words [0])) && (! "name".equals (words [0])))
	    	      _display += desc.get (i) + "<br><br>";
	           }
	      }
      }
  return _display;
  }

/**
 * 
 * @return A <code>String</code> made of HTML code that details fields of this
 *         <code>OntologyInstance</code>.
 */
 public String displayWithLinks ()
 {
  if (_display_with_links.equals (""))
     {
      String name = ((OntologyInstance) _the_object).getName ();
      String [] words = name.split(" ");
      if (words.length == 1)
         {
          _display_with_links += "<h1>" + name + "</h1><br>";
          String [] words2 = ((OntologyInstance) _the_object).getOntology ().getBaseURI ().split ("/");
          _display_with_links += "<h2>Id: <a href=\"" + words2 [words2.length - 1] + "#" + ((OntologyInstance) _the_object).getId () + "\">" + ((OntologyInstance) _the_object).getId () + "</a></h2><br>";
          return _display_with_links;
          }
      int intervals = name.length () / 15 + 1;

      String new_name = "";
      int id_word = 0;
      for (int i = 0; (i < intervals) && (id_word < words.length); i++)
          {
           while ((new_name.length () < 15 * (i + 1)) && (id_word < words.length))
           new_name += words [id_word++] + " ";
           new_name += "<br>";
           }
	  name = new_name;
      _display_with_links += "<h1>" + name + "</h1><br>";
      String [] words2 = ((OntologyInstance) _the_object).getOntology ().getBaseURI ().split ("/");
      _display_with_links += "<h2>Id: <a href=\"" + words2 [words2.length - 1] + "#" + ((OntologyInstance) _the_object).getId () + "\">" + ((OntologyInstance) _the_object).getId () + "</a></h2><br>";
      }
  return _display_with_links;
  }
 };