package alignment;

import java.io.*;

/**
 * Simple scoring scheme for the pairinf of two organs.
 *
 * @author Gilles Parmentier
 */
public class OrganSimplePairingScorer extends PairingScorer implements Serializable
{
 private static final long serialVersionUID = 1L;

 /**
  * Scoring function.
  * @return  The score of the pairing, 5.0 if the organs names are equaled, 0.0 otherwise.
  */
 // TODO: Ici il me reste a traiter le cas ou oi2 est un groupe d'homologie et non un simple organe.
 public double score (String oi1, String oi2)
 {
  if (oi1.equals (oi2))
     return 50.0;
  else
     return 0.0;
  }

 public double getValidatedHomologyScore () { return 75.0; }
 }