package datalayer;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;

import ontology.HomologyOntology;

/**
 * Reads an homology ontology in the OWL format as it has been written using this
 * application. For details on the format the the comments in <code>OwlWriter</code>.
 * 
 * @author admin
 */
public class OwlReader
{
 /**
  * The homology ontology that has been read on disk.
  */
 HomologyOntology _o;

 /**
  * The <code>BufferedReader</code> used to read the homology ontology.
  */
 BufferedReader _br;

 /**
  * @param f Absolute name of the file to read the homology ontology from.
  */
 public OwlReader (String f)
 {
  try
     {
      FileReader file = new FileReader (new File (f));
      _br = new BufferedReader (file);
      readHeader ();
      }
  catch (Exception e) {}
  }

 /**
  *
  */
 private void readHeader ()
 {

  }

 // Getters:
 public HomologyOntology getHomologyOntology () { return _o; }
 }
