package ontology;

import java.io.*;

public class OntologyProperty extends OntologyObject implements Serializable
{
 /**
  * 
  */
 private static final long serialVersionUID = 1L;
 // The classes that are link by this relation.
 // object is on the right side of the operator, subject on the left side.
 // Example: part_of is the property, brain is part_of head, brain is the subject, head the object.
 protected String _objectClass, _subjectClass;
 protected String _name;
 protected boolean _inversed;

 public OntologyProperty (String name, String id, String oc, String sc)
 {
  super (id);
  _name = name;
  _objectClass = oc;
  _subjectClass = sc;
  _inversed = false;
  }

 String getName () { return _name; }

 String getObjectClass () { return _objectClass; }

 String getSubjectClass () { return _subjectClass; }

 public void setInverse () { _inversed = true; }

 public boolean isInversed () { return _inversed; }

 public String toString () { return "Property: " + _name + "; id: " + _id ; }
 };