package visualization;

import ontology.OntologyInstance;
import ontology.OntologyObject;


/**
 * Stores the view of an ontology object.
 */
abstract class OntologyObjectView
{
 OntologyObject _the_object;
 String _display;

 OntologyObjectView (OntologyObject oo)
 {
  _the_object = oo;
  _display = "";
  }

 public abstract String display ();

 public String toString ()
 {
  Class <? extends OntologyObject> obj_class = _the_object.getClass ();
  if (obj_class.getName ().equals("ontology.OntologyInstance"))
	return ((OntologyInstance) _the_object).getName();
  return _the_object.toString ();
  }

 public OntologyObject getObject () { return _the_object; }
 };